package u6a4;

/**
 * Linked list of int-arrays.
 */
public class ChunkList {
	/**
	 * The size of each chunk.
	 */
	public final static int chunkSize = 20;
	
	/**
	 * The buffer of this chunk.
	 */
	public int buffer[];
	
	/**
	 * Reference to the rest of the list.
	 * 
	 * The empty list is encoded as null reference.
	 */
	public ChunkList next;
	
	/**
	 * Creates a new ChunkList with no follower.
	 */
	public ChunkList()
	{
		buffer = new int[chunkSize];
		next = null;
	}
	
	/**
	 * Returns the size of this list.
	 * 
	 * @return the size of this list
	 */
	public int size()
	{
		if (next == null) return 1;
		return 1 + next.size();
	}
	
	/**
	 * Returns the last element of this list.
	 * 
	 * @return the last element of this list
	 */
	public ChunkList last()
	{
		if (next == null) return this;
		return next.last();
	}
	
	/**
	 * Returns the the predecessor of a list which is a successor of this list.
	 * 
	 * @param successor 
	 * @returns the list for which successor is next. If there is no such list it returns null.
	 */
	public ChunkList predecessor(ChunkList successor)
	{
		if (next == null) return null;
		if (next == successor) return this;
		return next.predecessor(successor);
	}
}
